/** **********************************************************************

 This file is Generated by ADS "hpeesofmake pt2sys" command	           
 SystemC users are not allowed to make any change in this file.           
 Modifying this file may result in a non-functional Ptolemy-SystemC       
 Cosim. If you need to modify your design interface then modify your      
 .pl file instead.                                                        

 Copyright (c) 2007 Agilent Technologies Inc. All rights reserved.         

***************************************************************************/




#include "SystemCPtolemyInterface_PT_SC_InputSignal.hxx"
#include <iostream>


/** Forward declarations of functions used in SystemCPtolemyInterface_PT_SC_InputSignal */
extern "C" 
 { 
	 int setSCADS_Connection( char * token, SCADS_Connection ** connection, int numinputs, int numoutputs, int numparameters);
	 int processCommandArgs(int argc, char* argv[], char ***userarg ,char * connectionID);
	 int insertSCADS_Interface(SCADS_InterfaceList * interfacelist, const char *name, const char * type, const char * datatype);
	 SCADS_InterfaceList * newSCADS_InterfaceList(void);
	 void deleteSCADS_Interface(SCADS_InterfaceList * interfacelist);
	 int  checkSCADS_Compatibility(SCADS_InterfaceList * interfacelist, SCADS_Connection * adsConnection);
	 SCADS_Interface * getSCADS_InterfaceByName(char * name, SCADS_Connection * adsConnection, const char * direction );
	 double getSCADS_PortValue(SCADS_Interface * port, int tokennum);
	 double getSCADS_ParamValue(SCADS_Interface * param, int index, SCADS_Connection * adsConnection);
	 void writeSCADS_PortValue(SCADS_Interface * port, double value, int tokennum );
	 int getSCADS_PortNumTokens(SCADS_Interface * port);
	 int processADS_RunCommand(SCADS_Connection * adsConnection);
	 void notifyADS(SCADS_Connection * adsConnection);
	 void sendDataToADS(SCADS_Connection * adsConnection);
	 void stopRequestToADS(SCADS_Connection * adsConnection);
}

/****************************************************/


/** SystemC sc_main function. Please note that it is user's
 responsibility to invoke sc_start(-1) inside "ptolemy_sc_main" */

int sc_main(int argc, char* argv[]) {
	 char  adstoken[128];
	 char ** userarg;
	 int argcount = processCommandArgs( argc,  argv,&userarg, adstoken);
	 SystemCPtolemyInterface_PT_SC_InputSignal ptolemyInterface("PtolemyInterface", adstoken);

	 /* SystemC user must write sc_main(-1) inside "ptolemy_sc_main" */

	 ptolemy_sc_main( argcount, userarg, ptolemyInterface );
return 1;
}

/* ***************************************************/


SystemCPtolemyInterface_PT_SC_InputSignal::SystemCPtolemyInterface_PT_SC_InputSignal(sc_module_name name, char * connectiontoken) : sc_module(name) { 
	 int err = 0;
	 interfacelist = newSCADS_InterfaceList();
	 setSCADS_Connection( connectiontoken, &connection, 3, 1 , 0);


/* Adding input ports in the interface list to check for compatibility with ADS */
	 if (insertSCADS_Interface(interfacelist, "inputFreq", "INPUT", "DOUBLE")) err = 1;
	 if (insertSCADS_Interface(interfacelist, "inputNoiseMag", "INPUT", "DOUBLE")) err = 1;
	 if (insertSCADS_Interface(interfacelist, "inputMagnitude", "INPUT", "DOUBLE")) err = 1;

/* Adding output ports in the interface list to check for compatibility with ADS */
	 if (insertSCADS_Interface(interfacelist, "outputSignal", "OUTPUT", "DOUBLE")) err = 1;


/* Testing for SystemC-ADS interface compatibility */

	 if (checkSCADS_Compatibility(interfacelist,  connection) ) err = 1;


/* Initializing input pins. */
	 pin_inputFreq = getSCADS_InterfaceByName("inputFreq", connection, "INPUT" );
	 pin_inputNoiseMag = getSCADS_InterfaceByName("inputNoiseMag", connection, "INPUT" );
	 pin_inputMagnitude = getSCADS_InterfaceByName("inputMagnitude", connection, "INPUT" );

/* Initializing output pins. */
	 pin_outputSignal = getSCADS_InterfaceByName("outputSignal", connection, "OUTPUT" );

/* Calling go method for simulation runs.*/

	 SC_THREAD(go);
}

/* ************************************************************/

SystemCPtolemyInterface_PT_SC_InputSignal::~SystemCPtolemyInterface_PT_SC_InputSignal(){
	/* Sending stop request to ADS. */
	 stopRequestToADS(connection); 
	 deleteSCADS_Interface(interfacelist); 
}

/* ************************************************************/

void SystemCPtolemyInterface_PT_SC_InputSignal::go() {
	 int token;
	 while (1) { 
	 /* Checking that ADS has issued a Continue command or requested a stop. */
		 if(processADS_RunCommand(connection)) { sc_stop(); return;}

	/* Reading inputs from ADS. These are interface outputs. */
		 for( token=0; token < getSCADS_PortNumTokens(pin_inputFreq); token++) {
			 inputFreq.write( (double) getSCADS_PortValue(pin_inputFreq, token) );
 		 }

		 for( token=0; token < getSCADS_PortNumTokens(pin_inputNoiseMag); token++) {
			 inputNoiseMag.write( (double) getSCADS_PortValue(pin_inputNoiseMag, token) );
 		 }

		 for( token=0; token < getSCADS_PortNumTokens(pin_inputMagnitude); token++) {
			 inputMagnitude.write( (double) getSCADS_PortValue(pin_inputMagnitude, token) );
 		 }

	/* Writing outputs to ADS. These are interface inputs. */
		 for( token=0; token < getSCADS_PortNumTokens(pin_outputSignal); token++) {
			 writeSCADS_PortValue(pin_outputSignal, (double) outputSignal.read(), token );
		 }

	/* Sending COTINUES simulation command to ADS */
		 sendDataToADS(connection);

	 } 
 }
